//=============================================================================
//
//   File : kvi_heapobject.cpp
//   Created on Wed 24 Mar 2004 04:45:17 by Szymon Stefanek
//
//   This file is part of the KVIrc IRC client distribution
//   Copyright (C) 2004 Szymon Stefanek <pragma at kvirc dot net>
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#define __LIBKVILIB__

#include "kvi_heapobject.h"
#include "kvi_malloc.h"

// On windows we need to override new and delete operators
// to ensure that always the right new/delete pair is called for an object instance
// This bug jumps out because windows uses a local heap for each
// executable module (exe or dll).
// (this is a well known bug described in Q122675 of MSDN)

// on Linux it is not needed: there is a single global heap

#ifdef COMPILE_ON_WINDOWS
	void * KviHeapObject::operator new(size_t uSize)
	{
		return kvi_malloc(uSize);
	}
	
	void KviHeapObject::operator delete(void * pData)
	{
		kvi_free(pData);
	}
#endif


