//=============================================================================
//
//   File : kvi_scripttoolbar_button.cpp
//   Creation date : Fri Nov 08 2002 02:56:12 by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 2002 Szymon Stefanek (pragma at kvirc dot net)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//=============================================================================

#define __KVIRC__

#include "kvi_scripttoolbar_button.h"

#ifdef COMPILE_SCRIPTTOOLBAR

	#include "kvi_scripttoolbar_itemdefinition.h"
	#include "kvi_scripttoolbar.h"

	#include "kvi_iconmanager.h"
	
	#include "kvi_uparser.h"
	#include "kvi_window.h"
	#include "kvi_frame.h"

	KviScriptToolBarButton::KviScriptToolBarButton(KviScriptToolBar * pBar,KviScriptToolBarItemDefinition * pDef)
	: QToolButton(pBar), KviScriptToolBarItem(pBar,pDef)
	{
		updateText();
		updateIcon();
		setEnabled(m_pDef->enabled()); // default enabled state
		connect(this,SIGNAL(clicked()),this,SLOT(buttonClicked()));
	}

#else // !COMPILE_SCRIPTTOOLBAR

	KviScriptToolBarButton::KviScriptToolBarButton()
	: QToolButton(0), KviScriptToolBarItem()
	{
	}

#endif // !COMPILE_SCRIPTTOOLBAR

KviScriptToolBarButton::~KviScriptToolBarButton()
{
}

#ifdef COMPILE_SCRIPTTOOLBAR
	void KviScriptToolBarButton::updateText()
	{
		setTextLabel(m_pDef->text());
	}
	
	void KviScriptToolBarButton::updateIcon()
	{
		QPixmap * pix = g_pIconManager->getImage(m_pDef->icon());
		if(pix)setIconSet(*pix);
	}
	
	void KviScriptToolBarButton::setEnabledState(bool bEnabled)
	{
		setEnabled(bEnabled);
	}
#endif // COMPILE_SCRIPTTOOLBAR

void KviScriptToolBarButton::buttonClicked()
{
#ifdef COMPILE_SCRIPTTOOLBAR
	if(!m_pDef->code().isEmpty())
	{
		KviStr tmp = m_pDef->code();
		g_pUserParser->parseCommandBuffer(tmp.ptr(),m_pBar->frame()->activeWindow());
	}
#endif // COMPILE_SCRIPTTOOLBAR
}


