//
//   File : optw_textencoding.cpp
//   Creation date : Sat Aug 11 2001 03:29:52 CEST by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 2001 Szymon Stefanek (pragma at kvirc dot net)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
#include "optw_textencoding.h"

#include "kvi_options.h"
#include "kvi_locale.h"

#include "kvi_wstring.h"


KviTextEncodingOptionsWidget::KviTextEncodingOptionsWidget(QWidget * parent)
: KviOptionsWidget(parent,"textencoding_options_widget")
{
	createLayout(3,2);

	addLabel(0,0,0,0,__tr2qs("Default text encoding:"));

	m_pTextEncodingCombo = new QComboBox(this);
	addWidgetToLayout(m_pTextEncodingCombo,1,0,1,0);

	addRowSpacer(0,2,1,2);

	m_pTextEncodingCombo->insertItem(__tr2qs("Use Language Encoding"));
	for(unsigned int i=0;i<KviWStr::numberOfEncodings();i++)
	{
	//	QString tmp = KviWStr::encodingName(i);
	//	tmp += " (";
	//	tmp += KviWStr::encodingNameAlias(i);
	//	tmp += ")";
		m_pTextEncodingCombo->insertItem(KviWStr::encodingName(i));
	}

	if(KVI_OPTION_UINT(KviOption_uintDefaultTextEncoding) < KviWStr::numberOfEncodings())
	{
		m_pTextEncodingCombo->setCurrentItem(KVI_OPTION_UINT(KviOption_uintDefaultTextEncoding)+1);
	} else {
		m_pTextEncodingCombo->setCurrentItem(0);
	}
}

KviTextEncodingOptionsWidget::~KviTextEncodingOptionsWidget()
{
}

void KviTextEncodingOptionsWidget::commit()
{
	int idx = m_pTextEncodingCombo->currentItem();
	// guess from locale ?
	if((idx <= 0) || (idx > KviWStr::numberOfEncodings()))KVI_OPTION_UINT(KviOption_uintDefaultTextEncoding) = KVI_TEXT_ENCODING_UNKNOWN;
	else KVI_OPTION_UINT(KviOption_uintDefaultTextEncoding) = idx-1;
}

#include "m_optw_textencoding.moc"
