#ifndef _LIBKVITB_SCRIPTING_H_
#define _LIBKVITB_SCRIPTING_H_
//==============================================================================
//
//   File : libkvitb_scripting.h
//   Creation date : Wed 10 Mar 01:30:54 2004 GMT by Szymon Stefanek
//
//   This file is part of the KVirc irc client distribution
//   Copyright (C) 2004 Szymon Stefanek (pragma at kvirc dot net)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//==============================================================================


#include "kvi_mextoolbar.h"

class KviFrame;
class QToolButton;

class KviScriptingToolBar : public KviMexToolBar
{
	Q_OBJECT
public:
	KviScriptingToolBar(KviModuleExtensionDescriptor * d,KviFrame * par);
	~KviScriptingToolBar();
protected:
	QToolButton * m_pBtnAliasEditor;
	QToolButton * m_pBtnEventEditor;
	QToolButton * m_pBtnPopupEditor;
	QToolButton * m_pBtnRawEditor;
	QToolButton * m_pBtnToolBarEditor;
	QToolButton * m_pBtnCodeTester;
public:
	virtual void die();
protected slots:
	void showAliasEditor();
	void showEventEditor();
	void showPopupEditor();
	void showRawEditor();
	void showToolBarEditor();
	void newCodeTester();
	void reloadImages();
};

#endif //_LIBKVITB_SCRIPTING_H_
